import { VersionedSectionDirective } from './versioned-section.directive';
import {Component, DebugElement, NO_ERRORS_SCHEMA} from '@angular/core';
import {ComponentFixture, TestBed} from '@angular/core/testing';
import {DocumentService} from './services/document.service';
import {WindowService} from './services/window.service';
import {By} from '@angular/platform-browser';
import {VersionedSection} from 'facade-api';
import {FormsModule} from '@angular/forms';

@Component({
  selector: 'app-test-versioned-section-directive-component',
  template: '<input id="testContainer" [(ngModel)]="whatever" [(appVersionedSection)]="section">'
})
class TestVersionedSectionDirectiveComponent {
  public section?: VersionedSection;
  public whatever = '';
}

describe('VersionedSectionDirective', () => {
  let fixture: ComponentFixture<TestVersionedSectionDirectiveComponent>;
  let directive: VersionedSectionDirective;
  let container: DebugElement;
  beforeEach(() => {
    fixture = TestBed.configureTestingModule({
      declarations: [ TestVersionedSectionDirectiveComponent, VersionedSectionDirective ],
      imports: [FormsModule],
      providers: [
        DocumentService,
        WindowService
      ]
    })
      .createComponent(TestVersionedSectionDirectiveComponent);
    fixture.detectChanges(); // initial binding

    const tooltipDirectives = fixture.debugElement.queryAll(By.directive(VersionedSectionDirective));
    directive = tooltipDirectives[0].injector.get(VersionedSectionDirective) as VersionedSectionDirective;
    container = fixture.debugElement.query(By.css('#testContainer'));
  });
  it('should create an instance', () => {
    expect(directive).toBeTruthy();
  });

});
